{  X-Mailer

   OPEN SOURCE

   Programmiert von Bernd Dietzel (c)2003-2005  www.x-mailer.info  www.barret.de

   Programmiersprache Borland Delphi 7

   Bentigte Komponente : Indy 9   www.indyproject.org
}


unit UnitRemailer;  // Remailer-Auswahlfenster

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, ExtCtrls, ToolWin, ActnList, ExtActns,
  CheckLst;

type
  TFormRemailer = class(TForm)
    RemailerInfo: TGroupBox;
    StatusBar1: TStatusBar;
    MemoList: TMemo;
    ToolBar1: TToolBar;
    UpdateButton: TToolButton;
    PanelXmailerStatus: TPanel;
    Image1: TImage;
    Status: TPanel;
    Timer1: TTimer;
    ActionList1: TActionList;
    DownLoadRemailerList: TDownLoadURL;
    GroupBox1: TGroupBox;
    CheckboxRemailer: TCheckListBox;
    ToolButtonUbernehme: TToolButton;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButtonAlternativ: TToolButton;
    Splitter1: TSplitter;
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure UpdateButtonClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MemoListChange(Sender: TObject);
    procedure ToolButtonUbernehmeClick(Sender: TObject);
    procedure ToolButtonAlternativClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
    function TXT(TXTNr:integer):String;  {##Textstrings##}
  end;

var
  TXTs: TStringlist; {##extracted text vom Source##}
  FormRemailer: TFormRemailer;
  counter:integer;
  FileName:widestring;

implementation

uses XMAIL61,gnugettext;

{$R *.dfm}
 
{#### TEXT-STRINGS FROM SOURCE (c) 2004 by Bernd Dietzel  www.barret.de/textfromsource.zip ####} 
function TFormRemailer.TXT(TXTNr:integer):String;
begin
 if not Assigned(TXTs) then
 begin
  TXTs:=Tstringlist.create;
  with TXTs do begin
         {------- text list  -- Only Translate Intems with the {T}
{0}      Add('http://private.addcom.de/senshiremailer/rlist2.txt');
{1}   {T}Add(_('Fehler beim Download aus dem Internet'));
{2}   {T}Add(_('Update der Liste erfolgreich'));
{3}      Add('$REMAILER');
{4}      Add('PGPONLY');
{5}      Add('CPUNK');
{6}      Add('http://outel.org/mix/rlist2.txt');
{7}   {T}Add(_('Versuche Download'));
  end;
 end;
 Result := TXTs[TXTNr];
end;


procedure TFormRemailer.FormCreate(Sender: TObject);
begin
TranslateComponent (self);  {  gnugettext }
end;

procedure TFormRemailer.FormShow(Sender: TObject);
var
 S:widestring;
begin
 if checkboxRemailer.Items.Count>0 then ToolButtonUbernehme.Visible:=true else ToolButtonUbernehme.Visible:=false;
 counter:=0;
 timer1.enabled:=false;
 {*** Liste Local gespeichert unter :  \X-Einst\TXT\RLIST2.txt ****}
 FileName:=XMailerMemo+form1.TXT(530) {##RLIST2##} +'.'+ form1.TXT(220) {##txt##} ;
 if fileexists(FileName) then MemoList.Lines.LoadFromFile(FileName);
 downloadRemailerList.Filename:=XMailerEntwurf+form1.TXT(283){##tmp.dat##};
end;

procedure TFormRemailer.Timer1Timer(Sender: TObject);
begin
 Counter:=Counter+1;
 if counter=4 then     { nach 4sec aufhren }
 begin
  timer1.enabled:=false;
  status.Caption:=TXT(1) {##Fehler beim Download aus dem Internet##}
    + ' ' + downloadRemailerList.url;
  counter:=0;
 end;
 if fileexists(downloadRemailerList.Filename) then    { Datei aus Internet heruntergeladen ? }
 begin
  timer1.enabled:=false;
  RemailerInfo.Caption:=downloadRemailerList.url;
  status.Caption:=TXT(2) {##Update der Liste erfolgreich##}
      + ' ' + downloadRemailerList.url;
  MemoList.Lines.LoadFromFile(downloadRemailerList.Filename);
  form1.SpeichereMemo(form1.TXT(530){##RLIST2##} ,Memolist);
  form1.loesche(downloadRemailerList.Filename); { Temp-Datei Lschen }
 end;
end;

procedure TFormRemailer.ToolButtonAlternativClick(Sender: TObject);
begin
 UpdateButtonClick(ToolButtonAlternativ);
end;

procedure TFormRemailer.UpdateButtonClick(Sender: TObject);
begin
 if sender=UpdateButton then
 begin
  downloadRemailerList.url:=TXT(0) {##http://private.addcom.de/senshiremailer/rlist2.txt##} ;
 end
 else
 begin  { ToolButtonAlternativ }
  downloadRemailerList.url:=TXT(6) {##http://outel.org/mix/rlist2.txt##} ;
 end;
 status.Caption:=TXT(7)+' : '+downloadRemailerList.url;
 DownloadRemailerList.execute;  { Liste aus Internet herunterladen }
 counter:=0;
 timer1.enabled:=true; { warten bis Download fertig }
end;

procedure TFormRemailer.MemoListChange(Sender: TObject);
var
 i,p1,p2,x:integer;
 s,RemailerMail:string;
begin
 if MemoList.Lines.Count=0 then exit;

 checkboxRemailer.Clear;
 { Remailer in Checkliste eintragen }
 for i:=0 to MemoList.Lines.Count-1 do
 begin
  s:=uppercase(MemoList.Lines[i]);
  if pos(TXT(3) {##$REMAILER##} ,S)>0 then
  if pos(TXT(4) {##PGPONLY##}   ,S)=0 then
  if pos(TXT(5) {##CPUNK##}     ,S)>0 then
  begin
   p1:=pos('<',S);
   if p1>0 then
   begin
    p2:=pos('>',S);
    if p2>0 then
    begin
     RemailerMail:=copy(MemoList.Lines[i],p1+1,p2-p1-1);
     x:=checkboxRemailer.Items.Add(RemailerMail);
     checkboxRemailer.Checked[x]:=true;
    end; { if p2 }
   end; { if p1 }
  end; { if $REMAILER }
 end; { for i }

 if checkboxRemailer.Items.Count>0 then ToolButtonUbernehme.Visible:=true else ToolButtonUbernehme.Visible:=false;

end;

procedure TFormRemailer.ToolButtonUbernehmeClick(Sender: TObject);
var
 i,cou:integer;
begin
 if checkboxRemailer.Items.Count=0 then exit;

 cou:=0;
 for i:=0 to checkboxRemailer.Items.Count-1 do
 begin
  if checkboxRemailer.Checked[i]=true then inc(cou);
 end;
 if cou=0 then exit; { Alte Remailer nicht lschen wenn nichts angeklickt }

 { Alte Remailer lschen, neue bernehmen }
 form1.remailer.Items.Clear;
 form1.remailer.Items.Add(form1.TXT(4) {##AUS##} );
 for i:=0 to checkboxRemailer.Items.Count-1 do
 begin
  if checkboxRemailer.Checked[i]=true then
   form1.remailer.Items.Add(checkboxRemailer.Items.Strings[i]);
 end;
 form1.remailer.Text:=form1.remailer.Items.Strings[1];
 formremailer.Close; { Fenster schliessen }
end;

end.
