{  X-Mailer

   OPEN SOURCE

   Programmiert von Bernd Dietzel (c)2003-2005  www.x-mailer.info  www.barret.de

   Programmiersprache Borland Delphi 7

   Bentigte Komponente : Indy 9   www.indyproject.org
}



unit fMain3;  { "Testmail an mich selbst" - "meinen Mailserver suchen" - auch fr Search Robot }

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  IdTCPConnection, IdTCPClient, IdMessageClient, IdSMTP, IdComponent,
  IdUDPBase, IdUDPClient, IdDNSResolver, IdBaseComponent, IdMessage,
  StdCtrls, ExtCtrls, ComCtrls, IdAntiFreezeBase, IdAntiFreeze, Mask,
  Buttons, jpeg, ToolWin;

type
  TfrmMain3 = class(TForm)
    IdDNSResolver: TIdDNSResolver;
    IdSMTP: TIdSMTP;
    edtRecipient: TEdit;
    edtSubject: TEdit;
    mmoMessageText: TMemo;
    IdAntiFreeze: TIdAntiFreeze;
    edtTimeout: TMaskEdit;
    btnSendMail: TBitBtn;
    btnSchliessen: TBitBtn;
    edtNameServer: TComboBox;
    edtSender: TEdit;
    MemoServers: TMemo;
    PanelXmailerStatus: TPanel;
    Image2: TImage;
    Status: TPanel;
    GroupBoxSponsor: TGroupBox;
    Image1: TImage;
    Image3: TImage;
    LabelKontakt: TLabel;
    Label1: TLabel;
    Image4: TImage;
    LabelUsername: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Labelhost: TLabel;
    procedure FormShow(Sender: TObject);
    procedure btnSendMailClick(Sender: TObject);
    procedure btnSchliessenClick(Sender: TObject);
    procedure edtRecipientChange(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Image3Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  fMailServers : TStringList;
 function TXT(TXTNr:integer):String;  {##Textstrings##}
  Function PadZero(s:String):String;
  Function GetMailServers(Mailadresse:string):Boolean;
  Procedure SendMail;
  Function  SendMailHost(aHost : String):Boolean;
  Procedure Msg(aMessage:String);

  end;

var
  TXTs: TStringlist; {##extracted text vom Source##}
  frmMain3: TfrmMain3;
  frmMainAbbrechen:boolean;
  DNSs:string;

implementation

uses XMAIL61, relay3, Unitpostaus,gnugettext;

{$R *.DFM}
 
{#### TEXT-STRINGS FROM SOURCE (c) 2004 by Bernd Dietzel  www.barret.de/textfromsource.zip ####} 
function TfrmMain3.TXT(TXTNr:integer):String;
begin
 if not Assigned(TXTs) then
 begin
  TXTs:=Tstringlist.create;
  with TXTs do begin
         {------- text list  -- Only Translate Intems with the {T}
{0}    {T}Add(_(' ---> Suche den DNS-Server ...'));
{1}       Add('NS');
{2}       Add('DNS');      // Krzel fr DNS-Server
{3}       Add('NIC');
{4}       Add('ROOT');
{5}       Add('NAME');
{6}       Add('POST');     // Krzel fr Mailserver
{7}       Add('MX');
{8}       Add('SMTP');
{9}       Add('MAIL');
{10}   {T}Add(_('* Fehler *'));
{11}   {T}Add(_(' :-(  ---- Keine Antwort vom Name-Server ----- '));
{12}   {T}Add(_(' :-(  ---- Fehler beim Suchen des Name-Servers ---- '));
{13}   {T}Add(form1.TXT(4));       // intern ##AUS##
{14}   {T}Add(_('TESTMAIL'));      // intern siehe Form1.txt(369) + (371)
{15}   {T}Add(_('Senden ber Remailer : '));
{16}      Add('Anon-To:');
{17}   {T}Add(_('Empfnger:')+' ');
{18}   {T}Add(_('Server: '));
{19}   {T}Add(' '+_('Teste Server Nr.'));
{20}      Add(' : ');
{21}      Add(' ...');
{22}   {T}Add(_(' :-)  ++++++++++++++ E-Mail erfolgreich an')+' ');
{23}   {T}Add(' '+_('gesendet +++++++++++++++++'));
{24}      Add(form1.TXT(197));   // intern ROBOT
{25}   {T}Add(_(' :-(  -------------- E-Mail an')+' ');
{26}   {T}Add(' '+_('konnte nicht zugestellt werden -----------------'));
{27}   {T}Add(_('Testmail'));
{28}   {T}Add(_('*************** Robot gestartet ******************'));
{29}   {T}Add(_('----> Robot gestartet, BITTE WARTEN !!!!!! <---- '));
{30}      Add('  ');
{31}   {T}Add(form1.TXT(351)); // intern ##ABBRUCH##
{32}   {T}Add(_('*************** Robot beendet******************'));
{33}   {T}Add(form1.TXT(135)); // Status: bereit.
{34}   {T}Add(_(' :-|  Erfolgreich verbunden mit '));
{35}      Add(' ... ');
{36}   {T}Add(_('verbunden...'));
{37}   {T}Add(_(' :-|  Versuche Verbindung mit'+' '));
{38}   {T}Add(' '+_('zu trennen...'));
{39}   {T}Add(_(' :-)  Verbindung mit'));
{40}   {T}Add(_(' erfolgreich getrennt.'));
{41}   {T}Add(_('EMail abgelehnt :-( ...'));
  end;
 end;
 Result := TXTs[TXTNr];
end;


procedure TfrmMain3.FormCreate(Sender: TObject);
begin
TranslateComponent (self);  {  gnugettext }
end;


procedure TfrmMain3.FormShow(Sender: TObject);
var
 i:integer;
begin
  form1.TimerStatus.Enabled:=false;             { Status:bereit nach 15 Sec. vom Hauptfenster aus }
  labelhost.Caption:='';                        { fr *FEHLER* beim DNS-Server suchen lschen }
  frmMain3.showhint:=form1.showhint;            { Hilfetexte }
  edtNameServer.Text:=Robot.edtNameServer.Text; { Nameserver vom Robot-Fenster bernehmen }
  frmMainAbbrechen:=false;

  if robot.MemoGUTserver.Lines.Count>0 then
  begin
    edtNameServer.Text:=robot.MemoGUTserver.Lines[0];
    for i:=0 to robot.MemoGUTserver.Lines.Count-1 do
     edtNameServer.Items.Add(robot.MemoGUTserver.Lines[i]);
  end;

end;


{ Name im Memo nach Vorne sortieren, fr  Server Reihenfolge  }
procedure nachVORN(Name:String;MEMO:TMemo);
var
 LI,Posi,i,Start:integer;
 gefunden:boolean;
 tempLI:string;
begin
  LI:=MEMO.Lines.count;
  if LI<2 then exit; { mindestens 2 Eintrge um Namen zu sortieren }

  Start:=1; { zweiter Listeneintrag }

  gefunden:=true;
  while gefunden=true do
  begin
   application.ProcessMessages;

   Posi:=-1;
   for i:=Start to LI-1 do { Name in Liste suchen, nicht den ersten }
   begin
    if pos(uppercase(Name),uppercase(MEMO.lines[i]))>0 then Posi:=i
   end;

   if Posi=-1 then gefunden:=false
   else
   begin
    TempLI:=Memo.Lines[start-1];           { alten Eintrag merken  }
    Memo.Lines[start-1]:=Memo.Lines[posi]; { name nach Vorn Eintragen }
    Memo.Lines.Delete(Posi);               { Eintrag lschen }
    Memo.Lines.add(TempLI);                { alten Eintrag Hinten wieder anhngen }
    Inc(Start);                            { Start+1 damit nicht noch mal finden }
    Memo.Update;
    if start<LI-1 then gefunden:=true else gefunden:=false;
   end; { Posi>0 }

  end; { while gefunden }
  Memo.update;
  application.ProcessMessages;
end;


{ Name im Memo nach Hinten sortieren, fr  Server Reihenfolge  }
procedure nachHinten(Name:String;MEMO:TMemo);
var
 LI,Posi,i:integer;
 gefunden:boolean;
 tempLI:string;
begin
  LI:=MEMO.Lines.count;
  if LI<2 then exit; { mindestens 2 Eintrge um Namen zu sortieren }

  gefunden:=true;
  while gefunden=true do
  begin
   application.ProcessMessages;

   Posi:=-1;
   for i:=0 to LI-2 do { Name in Liste suchen, nicht den letzten Finden }
   begin
    if pos(uppercase(Name),uppercase(MEMO.lines[i]))>0 then Posi:=i
   end;

   if Posi=-1 then gefunden:=false
   else
   begin
    gefunden:=false;
    if LI>1 then
    begin
     TempLI:=Memo.Lines[Posi]; { Eintrag merken  }
     Memo.Lines.Delete(Posi);  { Eintrag lschen }
     Memo.Lines.add(TempLI);   { Hinten wieder anhngen }
     DEC(LI);                  { Listen-Eintrge -1 damit nicht noch mal finden }
     Memo.Update;
     gefunden:=true;
    end;
   end; { Posi>0 }

  end; { while gefunden }
  Memo.update;
  application.ProcessMessages;
end;



{ Den Mailserver des Empfngers mittels seiner E-Mailadresse ber einen Nameserver ermitteln }
function TfrmMain3.GetMailServers(Mailadresse:string): Boolean;
var
  i,x,dummy : integer;
  LDomainPart : String;
  LMXRecord : TMXRecord;
  NS:boolean;

begin
if frmMainAbbrechen=true then exit;

if assigned(frmMain3.fMailServers) then FreeAndNil(frmMain3.fMailServers);
if not assigned(fmailServers) then fMailServers := TStringList.Create;
fmailServers.clear;

Result := true;
with IdDNSResolver do     { Nameserverabfrage }
begin
  QueryResult.Clear;      { Ergebnisliste (Mailserver) der Nameserverabfrage }
  QueryRecords := [qtMX];

  { Name DNS-Server gltig ? , nein dann ersten aus den Liste der Nameserver }
  if length(DNSs)<5 then DNSs:=ROBOT.MemoGutserver.lines[0];
  Host :=DNSs;
  edtNameServer.text      :=DNSs;
  Robot.edtNameServer.Text:=DNSs;

  val(edtTimeout.text,x,dummy); { Reaktionszeit des Nameservers }
  ReceiveTimeout:=x;
  { aus  test@meinserver.de  -> meinserver.de }
  LDomainPart := copy(Mailadresse,pos('@',Mailadresse)+1,length(Mailadresse));

  form1.Status.caption:=frmMain3.TXT(0) {## ---> Suche den DNS-Server ...##} ; { Text NICHT in Name-Server ndern }
  try
  Resolve(LDomainPart);

  if QueryResult.Count > 0 then { Ergebnisliste (Mailserver) der Nameserverabfrage }
  begin
    for i := 0 to QueryResult.Count - 1 do
    begin
     application.ProcessMessages;
     LMXRecord := TMXRecord(QueryResult.Items[i]);
     fMailServers.Append(PadZero(IntToStr(LMXRecord.Preference)) + '=' + LMXRecord.ExchangeServer);
    end;

    Robot.Memomailserver.clear;
    Robot.Memomailserver.lines.clear;
    Robot.Memomailserver.update;
    application.ProcessMessages;
    { Sortierung der Mailserver und Zusatzinfos raus }
    fMailServers.Sorted := false;
    for i:=0 to fMailServers.count - 1 do
    begin
      application.ProcessMessages;
      x := pos('=',fMailServers.Strings[i]);
      if x > 0 then fMailServers.Strings[i] :=
        copy(fMailServers.Strings[i],x+1,length(fMailServers.Strings[i]));

      NS:=false; { ggf. gefundene Nameserver in der Ergebnis-Liste rausnehmen }
      if copy(uppercase(fMailServers.Strings[i]),1,2)=TXT(1) {##NS##}  then NS:=true;
      if pos(frmMain3.TXT(2) {##DNS##} ,uppercase(fMailServers.Strings[i]))>0   then NS:=true;
      if pos(frmMain3.TXT(3) {##NIC##} ,uppercase(fMailServers.Strings[i]))>0   then NS:=true;
      if pos(frmMain3.TXT(4) {##ROOT##} ,uppercase(fMailServers.Strings[i]))>0  then NS:=true;
      if pos(frmMain3.TXT(5) {##NAME##} ,uppercase(fMailServers.Strings[i]))>0  then NS:=true;
      if NS=false then { Mailserver }
      begin
       if Robot.MemoMailserver.lines.indexof(fMailServers.Strings[i])=-1 then
          Robot.MemoMailserver.lines.add(fMailServers.Strings[i]);
       Robot.MemoMailserver.update;
      end;
    end; { i:=0 to fMailServers.count - 1 }

    { Mailserver-Liste wieder lschen und neu, wird weiter unten wieder aufgefllt  }
    if assigned(frmMain3.fMailServers) then FreeAndNil(frmMain3.fMailServers);
    if not assigned(fmailServers) then fMailServers := TStringList.Create;
    fmailServers.clear;

    Robot.Memomailserver.update; { Mailserver in Robot-Memo }

    { "gute" Mailserver nach Vorn sortieren }
    nachVorn(frmMain3.TXT(6) {##POST##} ,ROBOT.MemoMailserver);    { z.B. post.webmailer.de }
    nachVorn(frmMain3.TXT(7) {##MX##}   ,ROBOT.MemoMailserver);    { z.B. MX2.web.de        }
    nachVorn(frmMain3.TXT(8) {##SMTP##} ,ROBOT.MemoMailserver);    { z.B. smtp.web.de       }
    nachVorn(frmMain3.TXT(9) {##MAIL##} ,ROBOT.MemoMailserver);    { z.B. mail.gmx.de       }

    { schlechte Mailserver nach Hinten sortieren }
    if Robot.MemoSchlechtServer.lines.count>0 then
    for i:=0 to Robot.MemoSchlechtServer.lines.count-1 do
    begin
     if Robot.MemoSchlechtServer.lines[i]<>'' then
      nachHinten(Robot.MemoSchlechtServer.lines[i],ROBOT.MemoMailserver);
    end;
    application.ProcessMessages;

    { Memo-Mailserver wieder in Mailserver-Stringliste }
    for i := 0 to Robot.MemoMailserver.lines.count - 1 do
    begin
      fMailServers.add(Robot.MemoMailserver.lines[i]);
    end;
    Robot.MemoMailserver.Lines[0]:=Robot.MemoMailserver.Lines[0]+''; { cursor nach oben }
    application.ProcessMessages;

    fMailServers.Duplicates := dupIgnore;
    Result := true;
    end

  else  { QueryResult.Count =0 , Keine Server zur Mailadresse gefunden }

  begin
    if labelhost.caption<>frmMain3.TXT(10) {##* Fehler *##}  then
    begin
      labelhost.caption:=frmMain3.TXT(10) {##* Fehler *##} ;
      { Text  Name-Server  nicht ndern }
      Msg(frmMain3.TXT(11) {## :-(  ---- Keine Antwort vom Name-Server ----- ##} +Host);
      if ROBOT.MemoSchlechtServer.Lines.IndexOf(Host)=-1 then Robot.MemoSchlechtServer.Lines.add(Host);
      Robot.MemoSchlechtserver.update;
      application.processmessages;
    end;
    Result := false;
  end;

  except
  on E : Exception do   { bei Ausnahmefehlern, z.B. Nameserver nicht mehr erreichbar }
  begin
    if labelhost.caption<>frmMain3.TXT(10) {##* Fehler *##}  then
    begin
      labelhost.caption:=frmMain3.TXT(10) {##* Fehler *##} ;
      { Text  Name-Server  nicht ndern }
      Msg(frmMain3.TXT(12) {## :-(  ---- Fehler beim Suchen des Name-Servers ---- ##} +Host );
      if ROBOT.MemoSchlechtServer.Lines.IndexOf(Host)=-1 then
         Robot.MemoSchlechtServer.Lines.add(Host);
      Robot.MemoSchlechtserver.update;
      application.processmessages;
    end;
    Result := false;
  end; {on E : Exception}

  end; { try }

end; { with IdDNSResolver }

Getmailservers:=result;
end;



{ Fhrende "0" hinzufgen wenn String nur ein Zeichen hat }
function TfrmMain3.PadZero(s: String): String;
begin
if length(s) < 2 then s := '0' + s;
Result := s;
end;



{ "TESTMAIL" oder "Robot"-Fenster ; Senden der Mail an "Anwen"  }
function SENDEN(wasdenn:string; AnWen:string; werdenn:integer):boolean;
                                            { werdenn = die Zeile im Memo wo "Anwen" steht }
var
 i,posS:integer;
 S:string;
 sendenERFOLGREICH:boolean;
 NameServerOK:boolean;
 Remailer:string;
begin
  form1.EMAIL.Recipients.EMailAddresses := AnWen;  { Empfnger Mail Adresse }
  frmMain3.edtRecipient.text            := Anwen;

  { Beim Senden mit Robot ber Remailer ist der Remailer der Empfnger, ANWEN in den Mailtext }
  Remailer:=Form1.remailer.text;
  if Remailer<>frmMain3.TXT(13) {##AUS##}  then
  begin
   if wasdenn<>frmMain3.TXT(14) {##TESTMAIL##}  then
   begin
    ROBOT.Memorelay.Lines.add(frmMain3.TXT(15) {##Senden ber Remailer : ##} +Remailer);
    form1.EMAIL.Recipients.EMailAddresses :=Remailer;
    frmMain3.edtRecipient.text            :=Remailer;
    Form1.EMAIL.Body.Strings[1]:=frmMain3.TXT(16) {##Anon-To:##} +AnWen; { ist bei GO schon fr ersten Empfnger erstellt worden }
   end;
  end;

  if Remailer<>frmMain3.TXT(13) {##AUS##}  then
  begin
    NameServerOK:=frmMain3.GetMailServers(Remailer); { SERVER holen, Remailer }
  end
  else
  begin
   NameServerOK:=frmMain3.GetMailServers(Anwen);    { SERVER holen, kein Remailer }
  end;

  if NameServerOK=true then
  begin
   { ***** Testmail ? dann Daten auf Hauptfenster bernehmen **** }
   if wasdenn=frmMain3.TXT(14) {##TESTMAIL##}  then
   begin
     form1.EMAIL.From.Text                  := frmMain3.edtSender.text; { sender=from }
     form1.EMAIL.Sender.Text                := frmMain3.edtSender.text;
     form1.EMAIL.Recipients.EMailAddresses  := AnWen;
     form1.EMAIL.Subject                    := frmMain3.edtSubject.text;
     form1.EMAIL.Body                       := frmMain3.mmoMessageText.Lines;
   end;
   ROBOT.Memorelay.Lines.add(frmMain3.TXT(17) {##Empfnger: ##} +AnWen);

   { ----- Gefundene Mailserver nacheinander testen ob er Mail an Empfnegr annimmt ----- }
   sendenERFOLGREICH:=false;
   for i := 0 to frmMain3.fMailServers.count -1 do
   begin
    application.ProcessMessages;
    if frmMainAbbrechen=true then exit;
    if sendenErfolgreich=false then
    begin
      frmMain3.labelhost.caption:=frmMain3.TXT(18) {##Server: ##} +frmMain3.fMailServers.Strings[i];
      frmMain3.labelhost.Update;
      frmMain3.Msg(frmMain3.TXT(19) {## Teste Server Nr.##} +inttostr(i+1)+frmMain3.TXT(20) {## : ##} +frmMain3.fMailServers.Strings[i]+frmMain3.TXT(21) {## ...##} );

      {####******* Haupt-Sende-Routine ********#####}
      if frmMain3.SendMailHost(frmMain3.fMailServers.Strings[i]) then
      begin
       { Mail-server und DNS-Server OK , aus schlecht-Liste austragen falls drin }
       posS:=ROBOT.MemoSchlechtServer.Lines.IndexOf(frmMain3.fMailServers.Strings[i]);
       if posS>0 then
       Robot.MemoSchlechtServer.lines.Delete(PosS);
       posS:=ROBOT.MemoSchlechtServer.Lines.IndexOf(Robot.edtNameserver.text);
       if posS>0 then
       Robot.MemoSchlechtServer.lines.Delete(PosS);
       Robot.MemoSchlechtserver.update;
       application.processmessages;

       frmMain3.labelhost.caption:=frmMain3.fMailServers.Strings[i];
       sendenERFOLGREICH:=true; {for i-schleife verlassen}
      end
      else
      begin   { Mailserver nicht gut }
       if ROBOT.MemoSchlechtServer.Lines.IndexOf(frmMain3.fMailServers.Strings[i])=-1 then
         Robot.MemoSchlechtServer.Lines.add(frmMain3.fMailServers.Strings[i]);
         Robot.MemoSchlechtserver.update;
         application.processmessages;
      end; { if sendMailhost }

    end; { if sendenerfolgreich = false }
   end; { frmMain3.fMailServers.count }

  { ----- ENDE Mailserver Testen ----- }

   if sendenErfolgreich=true  then
   begin
    frmMain3.Msg(frmMain3.TXT(22) {## :-)  ++++++++++++++ E-Mail erfolgreich an ##} +AnWen+frmMain3.TXT(23) {## gesendet +++++++++++++++++##} );
    ROBOT.MemoGO.lines[werdenn]:='';
    Robot.MemoGesendet.lines.add(Anwen);
    if Robot.MemoBAD.lines.IndexOf(Anwen)>0 then
     Robot.Memobad.lines.delete(Robot.MemoBAD.lines.IndexOf(Anwen));
    Robot.MemoBAD.Update;
    Robot.MemoGesendet.Update;
    application.ProcessMessages;

    if wasdenn=frmMain3.TXT(24) {##ROBOT##}  then
    begin
     { Mail in Ordner "gesendet" ablegen, Empfnger (aus An,CC,BCC) in Form1 ndern fr Speichern der Mail }
     S:=form1.mailto.Text;
     form1.mailto.Text:=AnWen;
     form1.mailto.Update;
     Form1.EMAILSPEICHERN(XmailerGesendet,wasdenn,Remailer); { wasdenn=ROBOT }
     form1.mailto.Text:=S; {Empfnger wieder zurcksetzen }
     form1.mailto.Update;
    end;
   end; { if sendenerfolgreich }

   if sendenErfolgreich=false then
   begin
    frmMain3.Msg(frmMain3.TXT(25) {## :-(  -------------- E-Mail an ##} +AnWen+frmMain3.TXT(26) {## konnte nicht zugestellt werden -----------------##} );
    if ROBOT.MemoBAD.lines.IndexOf(Anwen)=-1 then ROBOT.MemoBAD.lines.add(Anwen);
    Robot.MemoBAD.Update;
   end;

  end; { if Nameserver OK }

 SENDEN:=NameServerOK;
end;


{ guten DNS- Server suchen der nicht in der schlecht-Liste ist }
function NeuerDNSServer(Host:string):string;
var
 Z,x:integer;
begin
  Z:=Robot.MemoGutServer.Lines.count;
  while Z>0  do
  begin
   if Robot.MemoSchlechtserver.lines.IndexOf(Host)>-1 then
   begin
    DEC(Z);
    application.ProcessMessages;
    x:=Robot.MemoGutServer.Lines.IndexOf(Host);
    if x>-1 then
    begin
     Robot.MemoGutServer.Lines.Delete(x);
     Robot.MemoGutServer.Lines.add(Host); { nach Hinten sortieren }
     Robot.MemoGutServer.Update;
    end;
    Host:=Robot.MemoGUTserver.Lines[0]; { obersten Server nehmen }
    Robot   .edtNameServer.text:=Host;
    frmmain3.edtNameServer.text:=Host;
   end
   else Z:=0;
  end; { while Z }
  Robot.MemoGUTserver.Lines[0]:=Robot.MemoGUTserver.Lines[0]+''; { cursor nach oben }
  Robot.MemoGutServer.Update;
  application.ProcessMessages;
  NeuerDNSServer:=Host;
end;


procedure TfrmMain3.SendMail;
var
  Kopien,Nochmalserver:integer;
  NameServerCheck:boolean;
begin
 labelhost.caption:=''; { wird fr Mitteilungen ber Nameserverfehler gebraucht }

 { Testmail an mich selbst (sichtbares Formular) }
 if pos(TXT(27) {##Testmail##} ,frmMain3.caption)>0 then
 begin
  DNSs:=frmmain3.edtnameserver.text;
  SENDEN(TXT(14) {##TESTMAIL##} ,frmMain3.edtrecipient.text,0);
  exit;  {----> ***** Programmende bei Testmail , nicht bei Robot ***** }
 end;

 { ****Search Robot****** }
 with ROBOT do
 begin
    DNSs:=Robot.edtnameserver.text; { DNS-Server Variable global setzen }
    { Info fr den User  }
    Memorelay.clear;
    Status.caption:=frmMain3.TXT(28) {##*************** Robot gestartet ******************##} ;
    Memorelay.Lines.add(' ');
    Memorelay.Lines.add(frmMain3.TXT(29) {##----> Robot gestartet, BITTE WARTEN !!!!!! <---- ##} );
    Memorelay.Lines.add(frmMain3.TXT(30) {##  ##} );
    Memorelay.Update;
 end;

 {--- abarbeiten  Kopieempfnder die nicht schon gesendet sind ---- }
 for Kopien:=0 to ROBOT.MemoGO.lines.count-1 do
 begin
   application.ProcessMessages;

   if pos('@',ROBOT.MemoGO.lines[Kopien])>0 then { Empfnger-Adresse aus Liste schon gelscht ? }
   begin

      Nochmalserver:=Robot.MemoGutserver.lines.Count-1; { alle Mailserver nacheinander sendeversuch }
      while NochmalServer>0 do
      begin
        dec(NochmalServer);
           { ####***** SENDEN ****###### }
        NameServerCheck:=SENDEN(TXT(24) {##ROBOT##} ,ROBOT.MemoGO.lines[Kopien],Kopien);
        if NameServercheck=false then DNSs:=NeuerDNSServer(DNSs);
        if NameServercheck=true  then Nochmalserver:=0;
      end;

      if ((frmMainAbbrechen=true) or (Kopien=ROBOT.MemoGO.lines.count-1) or (ROBOT.Status.caption=TXT(31) {##ABBRUCH##} ) )
      then
      begin
        ROBOT.Status.caption:=TXT(32) {##*************** Robot beendet******************##} ; 
        form1.status.caption:=TXT(33) {##Status: bereit##} ;
        if ROBOT.MemoBAD.lines.count>0 then  ROBOT.ButtonRetry.Visible:=true;;
        exit; { *******Programmende ROBOT ********* }
     end;

   end;
 end; { for kopien }

end;


{ Hngt einen String in die Letzte Memozeile  an }
procedure MemoAppend(Anhaengen:string);
var
 c:integer;
begin
  c:=ROBOT.Memorelay.Lines.count-1;
  if c>0 then ROBOT.Memorelay.lines[c]:= ROBOT.Memorelay.lines[c]+Anhaengen;
  ROBOT.Memorelay.Update;
end;


{ Sendeversuch an einen Mail-Server (host) }
function TfrmMain3.SendMailHost(aHost: String): Boolean;
begin
Result := false;
with IdSMTP do
  begin
  Host := aHost;
  try
  Connect;
  application.ProcessMessages;
  form1.Status.caption:=frmMain3.TXT(34) {## :-|  Erfolgreich verbunden mit ##} +ahost+TXT(35) {## ... ##} ; form1.status.Update;
  MemoAppend(frmMain3.TXT(36) {##verbunden...##} );
  Send(form1.EMAIL);
  application.ProcessMessages;
  form1.Status.caption:=frmMain3.TXT(37) {## :-|  Versuche Verbindung mit ##} +ahost+TXT(38) {## zu trennen...##} ; form1.status.Update;
  Disconnect;
  application.ProcessMessages;
  form1.Status.caption:=frmMain3.TXT(39) {## :-)  Verbindung mit##} +ahost+TXT(40) {## erfolgreich getrennt.##} ; form1.status.Update;
  Result := true;
  except on E : Exception do
    begin
    if connected then try disconnect; except end;
    MemoAppend(frmMain3.TXT(41) {##EMail abgelehnt :-( ...##} );

    if ROBOT.MemoSchlechtServer.Lines.IndexOf(Host)=-1 then
      Robot.MemoSchlechtServer.Lines.add(Host);
    Robot.MemoSchlechtserver.update;
    application.processmessages;

    form1.Status.caption:=E.Message;
    result := false;
    end;
  end;
  end;
end;


{ Status anzeigen }
procedure TfrmMain3.Msg(aMessage: String);
begin
 form1.status.Caption:=aMessage;
 form1.status.update;
 if pos(TXT(27) {##Testmail##} ,frmMain3.caption)=0 then
 begin
  if ROBOT.Status.caption=TXT(31) {##ABBRUCH##}  then exit; { Robot-Status nicht ndern fr exit in der while-scheife }
  { Statusmeldung in das Robot-Memo schreiben bei Relay }
  ROBOT.memorelay.Lines.Add(aMessage);
  ROBOT.memorelay.Update;
  ROBOT.Status.caption:=aMessage;
  ROBOT.Status.Update;
  XAusgang.Status.caption:=aMessage;
  XAusgang.Status.update;
 end
 else
 begin
   Status.caption:= aMessage;
   Status.Update;
 end;
end;


{ GO!  (Buttons wrend des Sendens aus) }
procedure TfrmMain3.btnSendMailClick(Sender: TObject);
begin
 Msg('');
 btnSendMail.Enabled:=false;
 btnSchliessen.Enabled:=false;
 SendMail;
 btnSendMail.Enabled:=true;
 btnSchliessen.Enabled:=true;
end;

procedure TfrmMain3.btnSchliessenClick(Sender: TObject);
begin
 form1.TimerStatus.Enabled:=true;        { Hauptfenster-Status Timer wieder ein }
 form1.status.caption:=TXT(33) {##Status: bereit##} ;
 frmmain3.close;
end;


procedure TfrmMain3.edtRecipientChange(Sender: TObject);
begin
 if pos(TXT(14) {##TESTMAIL##} ,uppercase(frmmain3.caption))>0 then edtsender.Text:=edtrecipient.Text;
end;

procedure TfrmMain3.ToolButton1Click(Sender: TObject);
begin
{ Robot-Bild aus }
 //form1.terminator3Click(self);
end;


procedure TfrmMain3.Image3Click(Sender: TObject);
begin
 if xausgang.Angebot(4)=false then exit;
 frmMain3.Close;
end;

procedure TfrmMain3.Image1Click(Sender: TObject);
begin
 if xausgang.Angebot(3)=false then exit;
 frmMain3.Close;
end;

end.


